;================================================
;	POCKET PONG
;	ver 1.01a
;	for PC-G850 series
;	AASM 3.70
;	2006-09
;	by CHOI KYUN ikyuns@lily.freemail.ne.jpj
;================================================



	include	"MACRO.ASM"		;{}N
	include "DEF.ASM"		;e`

	org	0100h




Init:
	call	Cls			;ʏ
	call	Init_KEY		;L[
	call	Init_LCDC		;LCDC
	call	Init_BEEP		;BEEP

	call	Print_CREDIT		;ҕ\
	call	ClearAllScreen

;	call	Title			;^Cg\

	call	InitScore		;XRA
	call	InitStatus		;Xe[^Xʏ
	call	Randomize		;



ReStart:
	call	InitValue		;eϐ
	call	InitBall		;{[

	call	Ready

Main:
	{
		call	Inkey		;L[

		call	ClearWindow	;Q[ʂ̃NA
		call	DrawBg		;BG\

		call	MoveBar		;phړ
		call	MoveCom		;COMړ
		call	DispBar		;ph\

		call	MoveBall	;{[ړ
		call	DispBall	;{[\

		call	Pause		;|[Y
		call	GameOver	;Q[I[o[

		call	ChangeSe	;ʉ̐؂芷
		call	Filter		;ʔ]
		call	DispScreen	;XN[\

		in	a,(01fh)	;[BREAK]L[ŏI
		rlca
		jr	nc,continue
	}



Basic:
	call	Cls
	call	InfoVer_GAME		;o[W\
	call	InfoVer_LIB
	ret



;------------------------------------------------
;	^Cg\
;------------------------------------------------
Title:
	ret



;------------------------------------------------
;	ϐ
;------------------------------------------------
InitValue:
	ld	hl,19*256+7		;7,19
	ld	(you_x),hl

	ld	hl,19*256+84		;84,19
	ld	(com_x),hl

	ld	a,DEF_YOU_WAIT
	ld	(you_wait),a		;EFCgl

	xor	a
	ld	(over_flg),a		;Q[I[o[tO

	ld	a,DEF_RND_MOVE_STEP	;COMړ
	ld	(com_step),a

	ld	a,-1			;COMړ@-1:ړȂ
	ld	(com_vec),a

	ld	a,DEF_COM_WAIT		;COMEFCg
	ld	(com_wait),a
	ret



;------------------------------------------------
;	{[
;------------------------------------------------
InitBall:
	ld	a,DEF_BALL_WAIT		;EFCg
	ld	(ball_wait),a
	ld	(ball_wait_def),a

	ld	a,0000_0010b		;@
	ld	(ball_vec),a

	ld	hl,50*256+0
	call	Rnd
	and	15
	add	a,a
	add	a,h
	ld	h,a
	ld	(ball_x),hl		;XW@50+0..30,0

	ld	hl,0
	ld	(ball_y),hl

	ld	ix,Angle_data		;px
	call	Rnd
	and	3
	add	a,a			;*4
	add	a,a
	ld	e,a
	ld	d,0
	add	ix,de

	ld	l,(ix+0)
	ld	h,(ix+1)
	ld	(add_x),hl		;Xx

	ld	l,(ix+2)
	ld	h,(ix+3)
	ld	(add_y),hl		;Yx
	ret



;------------------------------------------------
;	Q[Jn
;------------------------------------------------
Ready:
	call	ClearWindow
	call	DrawBg		;BG\
	call	DispBar		;ph\
	call	Filter
	call	DispScreen

	ld	bc,3000
	jp	Wait



;------------------------------------------------
;	ʉ̐؂芷
;------------------------------------------------
ChangeSe:
	ld	a,(keyf)
	bit	KEY_CLS,a
	ret	z

	ld	a,(sound)
	xor	1
	ld	(sound),a

	ld	b,a
	add	a,a
	add	a,b
	rrca
	rrca
	ld	(_beep+1),a		;00H or 0C0H
	jp	Print_SE



;------------------------------------------------
;	Xe[^Xʏ
;------------------------------------------------
InitStatus:
	call	Print_LOGO		;S\
	call	Print_SE
	call	Print_HY
	call	Print_YOU

	call	DispScore		;XRA\
	ret



Print_LOGO:
	ld	hl,StatusTitle
	ld	de,96			;96,0..2
	ld	bc,46
	call	PutBitMap

	ld	hl,StatusTitle+46
	inc	d
	call	PutBitMap

	ld	hl,StatusTitle+46*2
	inc	d
	jp	PutBitMap



Print_SE:
	ld	a,(sound)
	add	a,a
	add	a,a
	add	a,a
	ld	e,a
	ld	d,0
	ld	hl,Icon_SE
	add	hl,de

	ld	de,5*256+137		;137,5
	ld	bc,8
	jp	PutBitmap



Print_HY:
	ld	hl,Font_HYPHEN		;nCt
	ld	de,4*256+115		;115,4
	ld	bc,8
	jp	PutBitmap



Print_YOU:
	ld	hl,Font_YOU		;YOU
	ld	de,3*256+96		;96,3
	ld	bc,11
	call	PutBitmap

	ld	hl,Font_COM		;COM
	ld	de,3*256+131		;131,3
;	ld	bc,11
	jp	PutBitmap



;------------------------------------------------
;	|[Y
;------------------------------------------------
Pause:
	ld	a,(keyf)
	bit	KEY_SHIFT,a
	ret	z
	call	Sound2
	call	Print_PAUSE
	call	Filter
	call	DispScreen
	{
		call	Inkey
		call	ChangeSe
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SHIFT,a
		jr	z,continue
	}
	call	Sound2
	call	Filter
	ret



Print_PAUSE:
	ld	hl,Font_PAUSE
	ld	de,5*256+0			;0,5
	ld	bc,26
	jp	PutBitmap



;------------------------------------------------
;	COMړ
;	ႮɂȂĂ܂cc
;------------------------------------------------
MoveCom:
	ld	hl,com_wait
	dec	(hl)
	ret	nz

	ld	(hl),DEF_COM_WAIT
	{
		inc	hl		;com_step
		dec	(hl)
		jr	nz,break

		call	SetComVec	;ړݒ
	}

_com_up:				;ړ
	ld	a,(com_vec)
	or	a
	jr	nz,_com_down
	{
		ld	a,(com_y)
		sub	1
		jr	nc,break

		xor	a
	}
	ld	(com_y),a
	ret

_com_down:				;ړ
	cp	-1			;-1:Ȃ
	ret	z
	{
		ld	a,(com_y)
		inc	a
		cp	48-8
		jr	c,break

		ld	a,48-8
	}
	ld	(com_y),a
	ret



	;ړ߂
	;HL=com_step
SetComVec:
	ld	a,(ball_vec)
	bit	BALL_LR,a
	jr	nz,_random_move		;_ړ

	ld	a,(ball_x+1)
	cp	50
	jr	c,_random_move

	ld	(hl),DEF_MOVE_STEP	;ړJEg
	{
		ld	a,(com_y)
		add	a,3
		ld	b,a
		ld	a,(ball_y+1)
;		inc	a
		cp	b
		jr	nc,break

		xor	a
		ld	(com_vec),a	;up
		ret
	}
	ld	a,1
	ld	(com_vec),a		;down
	ret


	;_Ɍ߂
_random_move:
	ld	(hl),DEF_RND_MOVE_STEP	;ړJEg

	ld	a,-1
	ld	(com_vec),a		;ړ 0:up 1:down -1:Ȃ

	call	Rnd
	and	3
	ret	nz
	{
		call	Rnd
		cp	127
		jr	c,break
		xor	a
		ld	(com_vec),a
		ret
	}
	ld	a,1
	ld	(com_vec),a		;0 or 1
	ret



;------------------------------------------------
;	phړ
;------------------------------------------------
MoveBar:
	ld	hl,you_wait
	dec	(hl)
	ret	nz

	ld	(hl),DEF_YOU_WAIT

	ld	hl,you_y
	ld	a,(key)


_up:
	bit	KEY_8,a			;ړ
	jr	z,_down

	ld	a,(hl)
	cp	1
	ret	c

	dec	(hl)
	ld	a,1
	ld	(bar_vec),a		;ړtO
	ret


_down:
	bit	KEY_2,a			;ړ
	jr	z,MoveBar_end

	ld	a,(hl)
	cp	48-8
	ret	nc

	inc	(hl)
	xor	a
	ld	(bar_vec),a		;ړtO
	ret


MoveBar_end:
	ld	a,-1
	ld	(bar_vec),a		;tOZbg
	ret



;------------------------------------------------
;	ph\
;------------------------------------------------
DispBar:
	ld	de,(you_x)
	ld	hl,Chr_BAR
	call	PutChr

	ld	de,(com_x)
	jp	PutChr



;------------------------------------------------
;	{[̃Xs
;------------------------------------------------
Spin:
	ld	hl,(add_y)
	ld	a,h
	cp	2
	ret	z

	ld	de,1
	add	hl,de
	ld	(add_y),hl
	ret



;------------------------------------------------
;	{[ړ
;------------------------------------------------
MoveBall:
	ld	hl,ball_wait
	dec	(hl)
	ret	nz

	ld	a,(ball_wait_def)
	ld	(hl),a

	call	CheckBar		;phƃ{[̓蔻
	call	Spin

	ld	a,(ball_vec)		;ړ
	ld	c,a
	ld	hl,(ball_y)
	ld	de,(add_y)


_ball_up:
	bit	BALL_UD,c		;ړ
	jr	z,_ball_down

	or	a			;Cy=0
	{
		sbc	hl,de
		jr	nc,break

		ld	h,0
		ld	a,BALL_UP		;]
		xor	c
		ld	c,a
		call	Sound1
	}
	ld	(ball_y),hl
	jr	_ball_left


_ball_down:					;ړ
	{
		add	hl,de
		ld	a,h
		cp	48-2
		jr	c,break

		ld	h,48-2
		ld	a,BALL_UP		;]
		xor	c
		ld	c,a
		call	Sound1
	}
	ld	(ball_y),hl


_ball_left:
	ld	hl,(ball_x)			;ړ
	ld	de,(add_x)

	bit	BALL_LR,c
	jr	z,_ball_right

	or	a
	{
		sbc	hl,de
		jr	nc,break
		ld	hl,0
		ld	a,YOU_LOSE		;
		ld	(over_flg),a
	}
	ld	(ball_x),hl
	jr	_ball_end


_ball_right:
	{
		add	hl,de			;Eړ
		ld	a,h
		cp	93-2
		jr	c,break
		ld	hl,(93-2)*256
		ld	a,YOU_WIN
		ld	(over_flg),a		;
	}
	ld	(ball_x),hl


_ball_end:
	ld	a,c
	ld	(ball_vec),a
	ret



;------------------------------------------------
;	phƃ{[̓蔻
;------------------------------------------------
CheckBar:
	;
_you:
	ld	hl,you_x
	ld	a,(ball_x+1)		;MX-EX+a<a+b+1
	sub	(hl)			;ball_x-you_x+1<1+2+1
	inc	a
	cp	1+2+1
	jr	nc,_com

	ld	hl,you_y
	ld	a,(ball_y+1)		;MY-EY+a<a+b+1
	sub	(hl)			;ball_y-you_y+1<1+7+1
	inc	a
	cp	1+7+1
	ret	nc

	call	SetNewAngle		;Vpxݒ
	call	SetNewVecter		;Vݒ

	ld	hl,10*256		;{[XW@X=10.00
	ld	(ball_x),hl

	jp	Sound2
;	ret


	;E
_com:
	ld	hl,com_x
	dec	(hl)
	ld	a,(ball_x+1)
	sub	(hl)
	inc	(hl)
	inc	a
	cp	1+2+1
	ret	nc

	ld	hl,com_y
	ld	a,(ball_y+1)
	sub	(hl)
	inc	a
	cp	1+7+1
	ret	nc

	call	SetNewAngle
	call	SetNewVecter

	ld	hl,81*256		;X=81.00
	ld	(ball_x),hl

	jp	Sound2
;	ret



;------------------------------------------------
;	Vpx߂
;	in:	A	px@0..8
;------------------------------------------------
SetNewAngle:
	ld	e,a
	ld	d,0
	ld	hl,Ball_wait_data	;{[x
	add	hl,de
	ld	a,(hl)
	ld	(ball_wait),a
	ld	(ball_wait_def),a

	ld	a,e
	add	a,a
	add	a,a			;~4
	ld	e,a
	ld	d,0
	ld	hl,Angle_data		;{[px
	add	hl,de

	push	hl
	pop	ix

	ld	l,(ix+0)
	ld	h,(ix+1)
	ld	(add_x),hl
	ld	l,(ix+2)
	ld	h,(ix+3)
	ld	(add_y),hl
	ret



;------------------------------------------------
;	V߂
;------------------------------------------------
SetNewVecter:
	ld	hl,ball_vec
	ld	a,(hl)
	ld	b,a

	xor	BALL_LEFT		;X̔]
	ld	(hl),a

	inc	hl
	ld	a,(hl)			;pḧړƃ{[r
	cp	-1
	ret	z			;ph͈ړĂȂ

	ld	a,b
	and	0000_0001b
	cp	(hl)			;]Ȃ
	ret	nz

	dec	hl
	ld	a,(hl)
	xor	BALL_UP			;Y]
	ld	(hl),a
	ret



;------------------------------------------------
;	{[\
;------------------------------------------------
DispBall:
	ld	hl,ball_x+1
	ld	e,(hl)
	inc	hl
	inc	hl
	ld	d,(hl)

	ld	hl,Chr_BALL
	jp	PutChr



;------------------------------------------------
;	Q[I[o[
;	in	(over_flg)
;------------------------------------------------
GameOver:
	ld	a,(over_flg)
	or	a
	ret	z

	call	Sound2
	call	Sound2
	{
		bit	0,a
		jr	z,break

		call	AddScore_YOU		;_Z
		jr	_restart
	}
	call	AddScore_COM


_restart:
	call	Print_PUSH
	call	Filter
	{
		call	Inkey
		call	ChangeSe
		call	DispScreen
		{
			in	a,(01fh)
			rlca
			jr	nc,break
			pop	af		;PCA
			jp	Basic		;イ[
		}
		ld	a,(keyf)
		bit	KEY_SPC,a
		jr	z,continue
	}
	pop	af
	jp	Restart



Print_PUSH:
	ld	hl,Font_PUSH
	ld	de,5*256+26		;26,5
	ld	bc,66
	jp	PutBitmap



;------------------------------------------------
;	af`
;------------------------------------------------
DrawBG:
	ld	hl,ScreenBuf+46		;46,0..5
	ld	b,6
	{
		ld	(hl),055h	;Z^[C
		inc	h
		djnz	continue
	}
	ret



;------------------------------------------------
;	tB^[Fʔ]
;------------------------------------------------
Filter:
	ld	e,WIN_HEIGHT
	ld	hl,ScreenBuf
	{
		ld	b,WIN_WIDTH
		push	hl
		{
			ld	a,(hl)
			xor	0ffh
			ld	(hl),a
			inc	hl
			djnz	continue
		}
		pop	hl
		inc	h

		dec	e
		jr	nz,continue
	}
	ld	hl,ScreenBuf
	ld	a,1111_1110b
	and	(hl)
	ld	(hl),a

	ld	hl,ScreenBuf+92
	ld	a,1111_1110b
	and	(hl)
	ld	(hl),a

	ld	hl,ScreenBuf+256*5+0
	ld	a,0111_1111b
	and	(hl)
	ld	(hl),a

	ld	hl,ScreenBuf+256*5+92
	ld	a,0111_1111b
	and	(hl)
	ld	(hl),a

	ret



;------------------------------------------------
;	XN[\@0-144
;------------------------------------------------
DispScreen:
	ld	hl,ScreenBuf
	jp	Send_LCDC
;	ret



;------------------------------------------------
;	EBhẼNA
;------------------------------------------------
ClearWindow:
	ld	hl,ScreenBuf+SCREEN_BLANK
	jp	ClearScreen
;	ret



;------------------------------------------------
;	ʉ
;------------------------------------------------

	;{[˕Ԃ
Sound1:
	push_all
	ld	hl,500
	ld	de,3
	call	Beep
	ld	hl,440
	ld	de,3
	call	Beep
	pop_all
	ret

	;phɓI
Sound2:
	push_all
	ld	hl,320
	ld	de,8
	call	Beep
	ld	hl,220
	ld	de,8
	call	Beep
	pop_all
	ret



;------------------------------------------------
;	XRA
;------------------------------------------------
InitScore:
	ld	hl,0
	ld	(sc_you),hl	;_
	ret



;------------------------------------------------
;	XRA\
;------------------------------------------------
DispScore:
	ld	hl,sc_you
	ld	de,4*256+96		;96,4
	call	PutBCD			;2\

	ld	hl,sc_com
	ld	de,4*256+127		;127,4
	jp	PutBCD			;2\



;------------------------------------------------
;	XRAZ
;------------------------------------------------
AddScore_YOU:
	ld	a,(sc_you)
	inc	a
	daa
	ld	(sc_you),a

	jr	DispScore



AddScore_COM:
	ld	a,(sc_com)
	inc	a
	daa
	ld	(sc_com),a

	jr	DispScore



;------------------------------------------------
;	o[W\
;------------------------------------------------
InfoVer_GAME:
	ld	hl,_g_ver
	ld	de,0000h		;X=0,Y=0
	ld	b,_g_end-_g_ver
	call	SYS_PUT_STRING
	ret


_g_ver:
	db	'POCKET PONG 1.01a'
_g_end:



	include	"LIB.ASM"		;Cu
	include "DATA.ASM"		;f[^
	include	"WORK.ASM"		;[NGA



	end
	